<?php
include ("wysiwyg/class.php");

function soc_bookmark($link, $title, $topic, $des, $icon = 'Y') {
	global $siteurl;
    $link = rawurlencode($link);
    $title = rawurlencode($title);
    $icon_folder = $siteurl."wysiwyg/icons/";
    $bookmark = array(
        #'BlinkBits'=>'http://www.blinkbits.com/bookmarklets/save.php?v=1&amp;source_url='.$link.'&amp;title='.$title,
        ##'Del.icio.us'=>'http://del.icio.us/post?v=2&amp;url='.$link.'&amp;title='.$title,
        'Digg'=>'http://digg.com/submit?phase=2&amp;url='.$link.'&amp;title='.$title.'&amp;topic='.htmlentities($topic).'&amp;bodytext='.htmlentities($des),
		'Facebook'=>'http://www.facebook.com/sharer.php?u='.$link.'&amp;t='.$title,
        ##'Fark'=>'http://cgi.fark.com/cgi/fark/submit.pl?new_url='.$link.'&amp;title='.$title,
        'Furl'=>'http://www.furl.net/savedialog.jsp?p=1&t='.$title.'&amp;v=1&amp;u='.$link,
        'Google'=>'http://www.google.com/bookmarks/mark?op=add&amp;bkmk='.$link.'&amp;title='.$title,
        ##'Ma.gnolia'=>'http://ma.gnolia.com/bookmarklet/add?url='.$link.'&amp;title='.$title,
        #'MyWeb'=>'http://myweb2.search.yahoo.com/myresults/bookmarklet?t='.$title.'&amp;u='.$link,
        'Netscape'=>'http://www.netscape.com/submit/?U='.$link.'&amp;T='.$title,
        ##'NetVouz'=>'http://netvouz.com/action/submitBookmark?url='.$link.'&amp;title='.$title.'&amp;description='.htmlentities($des).'&amp;popup=no',
        'Newsvine'=>'http://www.newsvine.com/_tools/seed&save?u='.$link.'&amp;h='.$title,
        'Reddit'=>'http://reddit.com/submit?url='.$link.'&amp;title='.$title,
        #'Shadows'=>'http://www.shadows.com/features/tcr.htm?url='.$link.'&amp;title='.$title,
        #'Simpy'=>'http://simpy.com/simpy/LinkAdd.do?title='.$title.'&amp;href='.$link,
        ##'Slashdot'=>'http://slashdot.org/bookmark.pl?url='.$link.'&amp;title='.$title,
        'Spurl'=>'http://www.spurl.net/spurl.php?v=3&amp;url='.$link.'&amp;title='.$title,
		'StumbleUpon'=>'http://www.stumbleupon.com/submit?url='.$link.'&amp;title='.$title,
        #'Technorati'=>'http://technorati.com/faves?add='.$link.'&amp;title='.$title,
    );
    foreach($bookmark as $key=>$value) {
        $link_text = $icon == 'Y' ? '<img src="'.$icon_folder.str_replace(".", '', strtolower($key)).'.jpg" alt="Post to '.$key.'" />' : $key;
        $a .= '<a href="'.$value.'" title="Post to '.$key.'">'.$link_text.'</a> ';
    }
	return $a;
}

function watermark($SourceFile, $WatermarkFile, $SaveToFile = NULL) {
// copyright bokehman.com
    $watermark = @imagecreatefrompng($WatermarkFile) or exit('Cannot open the watermark file.');

    imageAlphaBlending($watermark, false);
    imageSaveAlpha($watermark, true);

    $image_string = @file_get_contents($SourceFile) or exit('Cannot open image file.');
    $image = @imagecreatefromstring($image_string) or exit('Not a valid image format.');

    $imageWidth=imageSX($image);
    $imageHeight=imageSY($image);

    $watermarkWidth=imageSX($watermark);
    $watermarkHeight=imageSY($watermark);

    $coordinate_X = ( $imageWidth - 5) - ( $watermarkWidth);
    $coordinate_Y = ( $imageHeight - 5) - ( $watermarkHeight);

    imagecopy($image, $watermark, $coordinate_X, $coordinate_Y, 0, 0, $watermarkWidth, $watermarkHeight);

    if(!($SaveToFile)) header('Content-Type: image/jpeg');

    imagejpeg ($image, $SaveToFile, 100);
    imagedestroy($image);
    imagedestroy($watermark);

    if(!($SaveToFile)) exit;
}

function createThumbs($pathToImages, $pathToThumbs, $fname) {
global $setting;

    $info = pathinfo($pathToImages.$fname);
    // continue only if this is a JPEG image
    if (strtolower($info['extension']) == 'jpg')
    {

      // load image and get image size
      $img = imagecreatefromjpeg("{$pathToImages}{$fname}");
      $width = imagesx($img);
      $height = imagesy($img);

      // calculate thumbnail size
      $new_width = $setting["gallery_width"];
      //$new_height = floor( $height * ( $thumbWidth / $width ) );
	  $new_height = $setting["gallery_height"];

      // create a new temporary image
      $tmp_img = imagecreatetruecolor($new_width, $new_height);

      // copy and resize old image into new image
      imagecopyresized($tmp_img, $img, 0, 0, 0, 0, $new_width, $new_height, $width, $height);

      // save thumbnail into a file
      imagejpeg($tmp_img, "{$pathToThumbs}{$fname}", 100);
    }

	if (strtolower($info['extension']) == 'png')
    {

      // load image and get image size
      $img = imagecreatefrompng("{$pathToImages}{$fname}");
      $width = imagesx($img);
      $height = imagesy($img);

      // calculate thumbnail size
      $new_width = $setting["gallery_width"];
      //$new_height = floor( $height * ( $thumbWidth / $width ) );
	  $new_height = $setting["gallery_height"];

      // create a new temporary image
      $tmp_img = imagecreatetruecolor($new_width, $new_height);

      // copy and resize old image into new image
      imagecopyresized($tmp_img, $img, 0, 0, 0, 0, $new_width, $new_height, $width, $height);

      // save thumbnail into a file
      imagepng($tmp_img, "{$pathToThumbs}{$fname}", 9);
    }

	if (strtolower($info['extension']) == 'gif')
    {

      // load image and get image size
      $img = imagecreatefromgif("{$pathToImages}{$fname}");
      $width = imagesx($img);
      $height = imagesy($img);

      // calculate thumbnail size
      $new_width = $setting["gallery_width"];
      //$new_height = floor( $height * ( $thumbWidth / $width ) );
	  $new_height = $setting["gallery_height"];

      // create a new temporary image
      $tmp_img = imagecreatetruecolor($new_width, $new_height);

      // copy and resize old image into new image
      imagecopyresized($tmp_img, $img, 0, 0, 0, 0, $new_width, $new_height, $width, $height);

      // save thumbnail into a file
      imagegif($tmp_img, "{$pathToThumbs}{$fname}");
    }
}

function stats_check() {
global $pre;

if (date("m") == "01") {
$lmonth = "12";
$lyear = date("Y") -1;
} else {
$lmonth = date("m") - 1;
$lyear = date("Y");
}

if (date("W") == "01") {
$lweek = "52";
} else {
$lweek = date("W") - 1;
}

if (date("z") == "0") {
if (date("L") == "1") {
$lday = "366";
} else {
$lday = "365";
}
$lyear = date("Y") -1;
} else {
$lday = date("z") - 1;
$lyear = date("Y");
}

if ($lweek < "10") {
$lweek = "0".$lweek;
} else {
$lweek = $lweek;
}

if ($lmonth < "10") {
$lmonth = "0".$lmonth;
} else {
$lmonth = $lmonth;
}

$stat_last_week = mysql_fetch_row(mysql_query("SELECT month,year,week FROM ".$pre."stats WHERE year = '".$lyear."' AND week = '".$lweek."'"));
$stats_arch_check1 = mysql_num_rows(mysql_query("SELECT * FROM ".$pre."stats_archive WHERE year = '".$stat_last_week[1]."' AND week = '".$stat_last_week[2]."' AND name = 'last_week'"));

if (($stats_arch_check1 == 0) && ($stat_last_week[0])) {
$views1 = 0;
$uniques1 = 0;
$sql = mysql_query("SELECT * FROM ".$pre."stats WHERE year = '".$lyear."' AND week = '".$lweek."'");
while($r = mysql_fetch_array($sql)) {
$week1 = $r[week];
$month1 = $r[month];
$year1 = $r[year];
if ($r[type] == "view") {
$views1 = $views1 + 1;
}
if ($r[type] == "unique") {
$uniques1 = $uniques1 + 1;
}
}
mysql_query("DELETE FROM ".$pre."stats WHERE year = '".$lyear."' AND week = '".$lweek."'");
mysql_query("INSERT INTO ".$pre."stats_archive VALUES ('null', 'last_week', '".$week1."', '".$month1."', '".$year1."', '".$views1."', '".$uniques1."', '".time()."')");
mysql_query("INSERT INTO ".$pre."stats_archive VALUES ('null', 'stats', '".$week1."', '".$month1."', '".$year1."', '".$views1."', '".$uniques1."', '".time()."')");
}

if (mysql_num_rows(mysql_query("SELECT * FROM ".$pre."stats WHERE year = '".$lyear."' AND month = '".$lmonth."'")) == 0) {
$lyears = $lyear - 1;
$stat_last_month = mysql_fetch_row(mysql_query("SELECT month,year,week FROM ".$pre."stats WHERE year = '".$lyears."' AND month = '".$lmonth."'"));
} else {
$stat_last_month = mysql_fetch_row(mysql_query("SELECT month,year,week FROM ".$pre."stats WHERE year = '".$lyear."' AND month = '".$lmonth."'"));
}
$stats_arch_check2 = mysql_num_rows(mysql_query("SELECT * FROM ".$pre."stats_archive WHERE month = '".$stat_last_month[0]."' AND year = '".$stat_last_month[1]."' AND name = 'last_month'"));

if (($stats_arch_check2 == 0) && ($stat_last_month[1])) {
$views2 = 0;
$uniques2 = 0;
$sql2 = mysql_query("SELECT * FROM ".$pre."stats WHERE year = '".$lyear."' AND month = '".$lmonth."'");
while($r = mysql_fetch_array($sql2)) {
$week2 = $r[week];
$month2 = $r[month];
$year2 = $r[year];
if ($r[type] == "view") {
$views2 = $views2 + 1;
}
if ($r[type] == "unique") {
$uniques2 = $uniques2 + 1;
}
}
mysql_query("DELETE FROM ".$pre."stats WHERE year = '".$lyear."' AND month = '".$lmonth."'");
mysql_query("INSERT INTO ".$pre."stats_archive VALUES ('null', 'last_month', '".$week2."', '".$month2."', '".$year2."', '".$views2."', '".$uniques2."', '".time()."')");
mysql_query("INSERT INTO ".$pre."stats_archive VALUES ('null', 'stats', '".$week2."', '".$month2."', '".$year2."', '".$views2."', '".$uniques2."', '".time()."')");
}

$lyear = $lyear - 1;
$stat_last_year = mysql_fetch_row(mysql_query("SELECT month,year,week FROM ".$pre."stats WHERE year = '".$lyear."'"));
$stats_arch_check3 = mysql_num_rows(mysql_query("SELECT * FROM ".$pre."stats_archive WHERE year = '".$stat_last_year[1]."' AND name = 'last_year'"));

if (($stats_arch_check3 == 0) && ($stat_last_year[0])) {
$views3 = 0;
$uniques3 = 0;
$sql3 = mysql_query("SELECT * FROM ".$pre."stats WHERE year = '".$lyear."'");
while($r = mysql_fetch_array($sql3)) {
$week3 = $r[week];
$month3 = $r[month];
$year3 = $r[year];
if ($r[type] == "view") {
$views3 = $views3 + 1;
}
if ($r[type] == "unique") {
$uniques3 = $uniques3 + 1;
}
}
mysql_query("DELETE FROM ".$pre."stats WHERE year = '".$lyear."'");
mysql_query("INSERT INTO ".$pre."stats_archive VALUES ('null', 'last_year', '".$week3."', '".$month3."', '".$year3."', '".$views3."', '".$uniques3."', '".time()."')");
mysql_query("INSERT INTO ".$pre."stats_archive VALUES ('null', 'stats', '".$week3."', '".$month3."', '".$year3."', '".$views3."', '".$uniques3."', '".time()."')");
}
return $stats;
}

function translate() {
return "<form action='http://www.google.com/translate'>
<script language='JavaScript'>
document.write ('<input name=u value='+location.href+' type=hidden>')
</script>

<input name='hl' value='en' type='hidden'>
<input name='ie' value='UTF8' type='hidden'>
<input name='langpair' value='' type='hidden'>

<input name='langpair' value='en|fr' title='French' src= 'http://photos1.blogger.com/img/43/1633/320/13539949_e76af75976.jpg' onclick='this.form.langpair.value=this.value' height='20' type='image' width='30'>
<input name='langpair' value='en|de' title='German' src= 'http://photos1.blogger.com/img/43/1633/320/13539933_041ca1eda2.jpg' onclick='this.form.langpair.value=this.value' height='20' type='image' width='30'>
<input name='langpair' value='en|it' title='Italian' src= 'http://photos1.blogger.com/img/43/1633/320/13539953_0384ccecf9.jpg' onclick='this.form.langpair.value=this.value' height='20' type='image' width='30'>
<input name='langpair' value='en|pt' title='Portuguese' src= 'http://photos1.blogger.com/img/43/1633/320/13539966_0d09b410b5.jpg' onclick='this.form.langpair.value=this.value' height='20' type='image' width='30'>
<input name='langpair' value='en|es' title='Spanish' src= 'http://photos1.blogger.com/img/43/1633/320/13539946_2fabed0dbf.jpg' onclick='this.form.langpair.value=this.value' height='20' type='image' width='30'>
<input name='langpair' value='en|ja' title='Japanese' src= 'http://photos1.blogger.com/img/43/1633/320/13539955_925e6683c8.jpg' onclick='this.form.langpair.value=this.value' height='20' type='image' width='30'>
<input name='langpair' value='en|ko' title='Korean' src= 'http://photos1.blogger.com/img/43/1633/320/13539958_3c3b482c95.jpg' onclick='this.form.langpair.value=this.value' height='20' type='image' width='30'>
<input name='langpair' value='en|zh-CN' title='Chinese Simplified' src= 'http://photos1.blogger.com/img/43/1633/320/14324441_5ca5ce3423.jpg' onclick='this.form.langpair.value=this.value' height='20' type='image' width='30'>
</form>";
}

function check($val) {
   // remove all non-printable characters. CR(0a) and LF(0b) and TAB(9) are allowed
   // this prevents some character re-spacing such as <java\0script>
   // note that you have to handle splits with \n, \r, and \t later since they *are* allowed in some inputs
   $val = preg_replace('/([\x00-\x08][\x0b-\x0c][\x0e-\x20])/', '', $val);
   
   // straight replacements, the user should never need these since they're normal characters
   // this prevents like <IMG SRC=&#X40&#X61&#X76&#X61&#X73&#X63&#X72&#X69&#X70&#X74&#X3A&#X61&#X6C&#X65&#X72&#X74&#X28&#X27&#X58&#X53&#X53&#X27&#X29>
   $search = 'abcdefghijklmnopqrstuvwxyz';
   $search .= 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
   $search .= '1234567890!@#$%^&*()';
   $search .= '~`";:?+/={}[]-_|\'\\';
   for ($i = 0; $i < strlen($search); $i++) {
      // ;? matches the ;, which is optional
      // 0{0,7} matches any padded zeros, which are optional and go up to 8 chars
   
      // &#x0040 @ search for the hex values
      $val = preg_replace('/(&#[x|X]0{0,8}'.dechex(ord($search[$i])).';?)/i', $search[$i], $val); // with a ;
      // &#00064 @ 0{0,7} matches '0' zero to seven times
      $val = preg_replace('/(&#0{0,8}'.ord($search[$i]).';?)/', $search[$i], $val); // with a ;
   }
   
   // now the only remaining whitespace attacks are \t, \n, and \r
   $ra1 = Array('javascript', 'vbscript', 'expression', 'applet', 'meta', 'xml', 'blink', 'link', 'style', 'script', 'embed', 'object', 'iframe', 'frame', 'frameset', 'ilayer', 'layer', 'bgsound', 'title', 'base');
   $ra2 = Array('onabort', 'onactivate', 'onafterprint', 'onafterupdate', 'onbeforeactivate', 'onbeforecopy', 'onbeforecut', 'onbeforedeactivate', 'onbeforeeditfocus', 'onbeforepaste', 'onbeforeprint', 'onbeforeunload', 'onbeforeupdate', 'onblur', 'onbounce', 'oncellchange', 'onchange', 'onclick', 'oncontextmenu', 'oncontrolselect', 'oncopy', 'oncut', 'ondataavailable', 'ondatasetchanged', 'ondatasetcomplete', 'ondblclick', 'ondeactivate', 'ondrag', 'ondragend', 'ondragenter', 'ondragleave', 'ondragover', 'ondragstart', 'ondrop', 'onerror', 'onerrorupdate', 'onfilterchange', 'onfinish', 'onfocus', 'onfocusin', 'onfocusout', 'onhelp', 'onkeydown', 'onkeypress', 'onkeyup', 'onlayoutcomplete', 'onload', 'onlosecapture', 'onmousedown', 'onmouseenter', 'onmouseleave', 'onmousemove', 'onmouseout', 'onmouseover', 'onmouseup', 'onmousewheel', 'onmove', 'onmoveend', 'onmovestart', 'onpaste', 'onpropertychange', 'onreadystatechange', 'onreset', 'onresize', 'onresizeend', 'onresizestart', 'onrowenter', 'onrowexit', 'onrowsdelete', 'onrowsinserted', 'onscroll', 'onselect', 'onselectionchange', 'onselectstart', 'onstart', 'onstop', 'onsubmit', 'onunload');
   $ra = array_merge($ra1, $ra2);
   
   $found = true; // keep replacing as long as the previous round replaced something
   while ($found == true) {
      $val_before = $val;
      for ($i = 0; $i < sizeof($ra); $i++) {
         $pattern = '/';
         for ($j = 0; $j < strlen($ra[$i]); $j++) {
            if ($j > 0) {
               $pattern .= '(';
               $pattern .= '(&#[x|X]0{0,8}([9][a][b]);?)?';
               $pattern .= '|(&#0{0,8}([9][10][13]);?)?';
               $pattern .= ')?';
            }
            $pattern .= $ra[$i][$j];
         }
         $pattern .= '/i';
         $replacement = substr($ra[$i], 0, 2).'<x>'.substr($ra[$i], 2); // add in <> to nerf the tag
         $val = preg_replace($pattern, $replacement, $val); // filter out the hex tags
         if ($val_before == $val) {
            // no replacements were made, so exit the loop
            $found = false;
         }
      }
   }
   return $val;
}

function email($mail) {
$ret_mail="";
$len=strlen($mail);
for($x=0;$x<$len;$x++)
{
$ord=ord(substr($mail,$x,1));
$ret_mail.="&#$ord;";
}
return $ret_mail;
}

function check_domain($url) {	
	$info = parse_url($url);
	if ($info['host'] == "")
	$domain = $info['path'];
	else
	$domain = $info['host'];
	
	if (substr_count($domain, ".") == 1) {
 	$output = $domain;
	} else {
  	
	if (preg_match("#([^\.\/]*\.(co|biz|com|edu|gov|info|mil|net|org)\.(ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|bb|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw))#is", $domain, $output)) {
    $output = $output[1];
   	} else {
    $domain = explode(".", $domain);
    $output = $domain[count($domain)-2].".".$domain[count($domain)-1];
  	}
	}
	return $output;
}

function text_quote ($str) {
    $open = '<blockquote>';
    $close = '</blockquote>';

    // How often is the open tag?
    preg_match_all('/\[quote\]/i', $str, $matches);
    $opentags = count($matches['0']);

    // How often is the close tag?
    preg_match_all ('/\[\/quote\]/i', $str, $matches);
    $closetags = count($matches['0']);

    // Check how many tags have been unclosed
    // And add the unclosing tag at the end of the message
    $unclosed = $opentags - $closetags;
    for ($i = 0; $i < $unclosed; $i++) {
        $str .= '</blockquote>';
    }

    // Do replacement
    $str = str_replace('[' . 'quote]', $open, $str);
    $str = str_replace('[/' . 'quote]', $close, $str);

    return $str;
}

function parse_text($str) {
    $str = htmlentities($str);

    $simple_search = array(
                '/\[b\](.*?)\[\/b\]/is',                                
                '/\[i\](.*?)\[\/i\]/is',                                
                '/\[u\](.*?)\[\/u\]/is',                                
                '/\[url\=(.*?)\](.*?)\[\/url\]/is',                         
                '/\[url\](.*?)\[\/url\]/is',                             
                '/\[align\=(left|center|right)\](.*?)\[\/align\]/is',    
                '/\[img\](.*?)\[\/img\]/is',                            
                '/\[mail\=(.*?)\](.*?)\[\/mail\]/is',                    
                '/\[mail\](.*?)\[\/mail\]/is',                            
                '/\[font\=(.*?)\](.*?)\[\/font\]/is',                    
                '/\[size\=(.*?)\](.*?)\[\/size\]/is',                    
                '/\[color\=(.*?)\](.*?)\[\/color\]/is',        
                );

    $simple_replace = array(
                '<strong>$1</strong>',
                '<em>$1</em>',
                '<u>$1</u>',
                '<a href="$1">$2</a>',
                '<a href="$1">$1</a>',
                '<div style="text-align: $1;">$2</div>',
                '<img src="$1" />',
                '<a href="mailto:$1">$2</a>',
                '<a href="mailto:$1">$1</a>',
                '<span style="font-family: $1;">$2</span>',
                '<span style="font-size: $1;">$2</span>',
                '<span style="color: $1;">$2</span>',
                );

    // Do simple BBCode's
    $str = preg_replace ($simple_search, $simple_replace, $str);
    // Do <blockquote> BBCode
    $str = text_quote($str);
 
    return html_entity_decode(stripslashes($str));
}

function search_box() {
global $pre;
global $siteurl;

$a .= "<form action='".$siteurl."index.php' method='get'><input type='hidden' name='view' value='search'><input type='text' name='search'><br /><br /><select name='section'><option value=''>-------</option>";
$cat = mysql_query("SELECT * FROM ".$pre."sections ORDER BY `name` ASC");
for($i = 0; $r = mysql_fetch_assoc($cat); $i++) {
$a .= "<option value='".$r[name]."'>".ucwords($r[name])."</option>";
}
$a .= "</select>&nbsp;&nbsp;&nbsp;&nbsp;<input type='submit' value='Search'></form>";
return $a;
}

function table($tablename) {
global $dbname;

   $result = @mysql_list_tables($dbname);
   $rcount = @mysql_num_rows($result);

   for ($i=0;$i<$rcount;$i++) {
       if (@mysql_tablename($result, $i)==$tablename) return true;
   }
   return false;
}

function header_functions() {
global $pre;
if (($_COOKIE['adaptcms_skin']) or ($_POST['skin'])) {
if ($_COOKIE['adaptcms_skin']) {
$skin = $_COOKIE['adaptcms_skin'];
}
if ($_POST['skin']) {
$skin = $_POST['skin'];
}
} else {
$skin = "skin1";
}
if ($skin == "skin1") {
$color = "#feb011";
$color2 = "#4A4A4A";
}
if ($skin == "skin2") {
$color = "#db1c1c";
$color2 = "white";
}
if ($skin == "skin3") {
$color = "#5400ff";
$color2 = "white";
}
if ($skin == "skin4") {
$color = "#176b12";
$color2 = "white";
}
if ($skin == "skin5") {
$color = "#64126b";
$color2 = "white";
}

$num1 = @mysql_num_rows(@mysql_query("SELECT * FROM ".$pre."articles WHERE ver = ''"));
$time = "0";
$qquery = mysql_query("SELECT * FROM ".$pre."users ORDER BY `id` DESC");
while($q = mysql_fetch_array($qquery)) {
$time1 = "";
$time2 = "";
$time1 = time() - 901;
$time2 = time() + 1;
if (($q[logged] < $time2) && ($q[logged] > $time1)) {
$time = $time + 1;
}
}
$user = $_COOKIE[adaptcms_username];
$num1 = @mysql_num_rows(@mysql_query("SELECT * FROM ".$pre."articles WHERE ver = ''"));
}

function hilite($var) {
return "<font style='background-color: #FFFF00'>".$var."</font>";
}

function abclist($url) {
global $setting;
global $mrw;
global $mrw_1;

if (strtolower($setting["mod_rewrite"]) == "yes") {
$url .= "letter/";
return "<center><a href='".$mrw["archive"]."'><b><u>All</u></b></a>&nbsp;&nbsp;<a href='".$url."0-9/'>#</a>&nbsp;&nbsp;<a href='".$url."A/'>A</a>&nbsp;&nbsp;<a href='".$url."B/'>B</a>&nbsp;&nbsp;<a href='".$url."C/'>C</a>&nbsp;&nbsp;<a href='".$url."D/'>D</a>&nbsp;&nbsp;<a href='".$url."E/'>E</a>&nbsp;&nbsp;<a href='".$url."F/'>F</a>&nbsp;&nbsp;<a href='".$url."G/'>G</a>&nbsp;&nbsp;<a href='".$url."H/'>H</a>&nbsp;&nbsp;<a href='".$url."I/'>I</a>&nbsp;&nbsp;<a href='".$url."J/'>J</a>&nbsp;&nbsp;<a href='".$url."K/'>K</a>&nbsp;&nbsp;<a href='".$url."L/'>L</a>&nbsp;&nbsp;<a href='".$url."M/'>M</a>&nbsp;&nbsp;<a href='".$url."N/'>N</a>&nbsp;&nbsp;<a href='".$url."O/'>O</a>&nbsp;&nbsp;<a href='".$url."P/'>P</a>&nbsp;&nbsp;<a href='".$url."Q/'>Q</a>&nbsp;&nbsp;<a href='".$url."R/'>R</a>&nbsp;&nbsp;<a href='".$url."S/'>S</a>&nbsp;&nbsp;<a href='".$url."T/'>T</a>&nbsp;&nbsp;<a href='".$url."U/'>U</a>&nbsp;&nbsp;<a href='".$url."V/'>V</a>&nbsp;&nbsp;<a href='".$url."W/'>W</a>&nbsp;&nbsp;<a href='".$url."X/'>X</a>&nbsp;&nbsp;<a href='".$url."Y/'>Y</a>&nbsp;&nbsp;<a href='".$url."Z/'>Z</a></center><br />";
} else {
$url2 = "";
return "<center><a href='".$mrw["archive"]."'><b><u>All</u></b></a>&nbsp;&nbsp;<a href='$type".$url2."abc=0-9'>#</a>&nbsp;&nbsp;<a href='$type".$url2."abc=A'>A</a>&nbsp;&nbsp;<a href='$type".$url2."abc=B'>B</a>&nbsp;&nbsp;<a href='$type".$url2."abc=C'>C</a>&nbsp;&nbsp;<a href='$type".$url2."abc=D'>D</a>&nbsp;&nbsp;<a href='$type".$url2."abc=E'>E</a>&nbsp;&nbsp;<a href='$type".$url2."abc=F'>F</a>&nbsp;&nbsp;<a href='$type".$url2."abc=G'>G</a>&nbsp;&nbsp;<a href='$type".$url2."abc=H'>H</a>&nbsp;&nbsp;<a href='$type".$url2."abc=I'>I</a>&nbsp;&nbsp;<a href='$type".$url2."abc=J'>J</a>&nbsp;&nbsp;<a href='$type".$url2."abc=K'>K</a>&nbsp;&nbsp;<a href='$type".$url2."abc=L'>L</a>&nbsp;&nbsp;<a href='$type".$url2."abc=M'>M</a>&nbsp;&nbsp;<a href='$type".$url2."abc=N'>N</a>&nbsp;&nbsp;<a href='$type".$url2."abc=O'>O</a>&nbsp;&nbsp;<a href='$type".$url2."abc=P'>P</a>&nbsp;&nbsp;<a href='$type".$url2."abc=Q'>Q</a>&nbsp;&nbsp;<a href='$type".$url2."abc=R'>R</a>&nbsp;&nbsp;<a href='$type".$url2."abc=S'>S</a>&nbsp;&nbsp;<a href='$type".$url2."abc=T'>T</a>&nbsp;&nbsp;<a href='$type".$url2."abc=U'>U</a>&nbsp;&nbsp;<a href='$type".$url2."abc=V'>V</a>&nbsp;&nbsp;<a href='$type".$url2."abc=W'>W</a>&nbsp;&nbsp;<a href='$type".$url2."abc=X'>X</a>&nbsp;&nbsp;<a href='$type".$url2."abc=Y'>Y</a>&nbsp;&nbsp;<a href='$type".$url2."abc=Z'>Z</a></center><br />";
}
}

function fthrough($var, $cat, $id) {
$namepart = str_replace(" ", "-", stripslashes($var));
$namepart = str_replace("--", "", $namepart);
$namepart = str_replace("_", "-", $namepart);
$namepart = str_replace("?", "", $namepart);
$namepart = str_replace("!", "", $namepart);
$namepart = str_replace(":", "", $namepart);
$namepart = str_replace("'", "", $namepart);
$namepart = str_replace("`", "", $namepart);
$namepart = str_replace("", "", $namepart);
$namepart = str_replace("(", "", $namepart);
$namepart = str_replace(")", "", $namepart);
$namepart = str_replace("[", "", $namepart);
$namepart = str_replace("]", "", $namepart);
$namepart = str_replace("/", "-", $namepart);
$namepart = str_replace(",", "", $namepart);
$namepart = str_replace(".", "", $namepart);
$namepart = str_replace('"', "", $namepart);
$namepart = str_replace("'", "", $namepart);
$namepart = str_replace("@", "at", $namepart);
$namepart = str_replace("", "", $namepart);
$namepart = str_replace("", "", $namepart);
$namepart = str_replace("+", "plus", $namepart);
$namepart = str_replace("%", "", $namepart);
$namepart = str_replace("*", "", $namepart);
$namepart = str_replace("&", "and", $namepart);
$namepart = str_replace("#", "", $namepart);

$section = str_replace(" ", "-", ucwords(stripslashes($cat)));
$section = str_replace("--", "", $section);
$section = str_replace("_", "-", $section);
$section = str_replace(":", "", $section);
$section = str_replace("'", "", $section);
$section = str_replace("/", "-", $section);
$section = str_replace('"', "", $section);
$section = str_replace("'", "", $section);

if ($id) {
if ($cat) {
return $id."/".$section."/".$namepart."/";
} else {
return $id."/".$namepart."/";
}
} else {
return $namepart;
}
}

function show_poll($pid, $pname) {
global $pre;
global $setting;
global $siteurl;

if (($pid) && ($pname == "")) {
$pname2 = mysql_fetch_row(@mysql_query("SELECT pname,votes FROM ".$pre."polls WHERE id = '".$pid."' AND type = 'poll'"));
$pname = $pname2[0];
$total = $pname2[1];
$num = $total;
} else {
$pname2 = mysql_fetch_row(@mysql_query("SELECT votes FROM ".$pre."polls WHERE id = '".$pid."' AND type = 'poll'"));
$total = $pname2[0];
$num = $total;
}

if ($_COOKIE["poll_".$pid] == "") {
$poll_header = "<form action='".$_SERVER['REQUEST_URI']."' method='post'><input type='hidden' name='question' value='".stripslashes(urlencode(stripslashes($pname)))."'><input type='hidden' name='pid' value='".$pid."'>";
}

$temp2 = @mysql_fetch_row(@mysql_query("SELECT template FROM ".$pre."templates WHERE name = 'poll_options'"));
$sql = @mysql_query("SELECT * FROM ".$pre."polls WHERE pname = '".$pname."' AND type = 'option' ORDER BY `id` ASC");
while($r = @mysql_fetch_array($sql)) {
$pab = "";$rab = "";

if ($num == "0") {
$num = "1";
}
@$nu = @$r[votes]/$num;

if (($num == $r[votes]) && ($r[votes] > "0")) {
$nua = "100";
} else {
if ($r[votes] == "0") {
$nua = "0";
} else {
$nua = substr($nu, 2, 2);
}
}

if (($nu < "10") && ($nu > "0")) {
$nua = $nu * 100;
}

if (($num == $r[votes]) && ($r[votes] == "0")) {
$nua = "0";
}

if ($setting["poll_type"] == "graphic") {
if ($nua > "0") {
$img = "<tr><td><img src='".$siteurl."wysiwyg/poll.jpg' width='".$nua."%' height='10'></td></tr>";
} else {
$img = "<tr><td><img src='".$siteurl."wysiwyg/poll.jpg' width='1%' height='10'></td></tr>";
}
}

$pab[] = "{name}";
$pab[] = "{data}";
$rab[] = stripslashes($r[name]);
if ($_COOKIE["poll_".$pid] == "") {
$rab[] = "<input type='radio' name='answer' value='".$r[name]."'>";
} else {
$rab[] = substr($nua,0,4)."%".$img;
}

$poll_options .= str_replace($pab, $rab, stripslashes($temp2[0]));
}

if ($_COOKIE["poll_".$pid] == "") {
$temp1 = @mysql_fetch_row(@mysql_query("SELECT template FROM ".$pre."templates WHERE name = 'poll_vote'"));
} else {
$temp1 = @mysql_fetch_row(@mysql_query("SELECT template FROM ".$pre."templates WHERE name = 'poll_results'"));
}
$sab[] = "{question}";
$sab[] = "{options}";
$sab[] = "{submit}";
$sab[] = "{vote_total}";

$tab[] = stripslashes($pname);
$tab[] = $poll_options;
if ($_COOKIE["poll_".$pid] == "") {
$tab[] = "<input type='submit' value='Vote'>";
} else {
$tab[] = "";
}
$tab[] = $total;

if ($_COOKIE["poll_".$pid] == "") {
return $poll_header.str_replace($sab, $tab, stripslashes($temp1[0]))."</form>";
} else {
return $poll_header.str_replace($sab, $tab, stripslashes($temp1[0]));
}
}

function content($temp, $cat, $limit, $sort, $sortby) {
global $pre;
global $mrw_1;
global $mrw;
global $lev;
global $setting;
global $siteurl;

if ($limit == "") {
$limit = "5";
}
if ($sort == "") {
$sort = "id";
}
if ($sortby == "") {
$sortby = "DESC";
}

if ($cat) {
$sql = @mysql_query("SELECT * FROM ".$pre."articles WHERE section = '".$cat."' AND ver = '' ORDER BY `".$sort."` ".$sortby." LIMIT ".$limit);
} else {
$sql = @mysql_query("SELECT * FROM ".$pre."articles WHERE ver = '' ORDER BY `".$sort."` ".$sortby." LIMIT ".$limit);
}
while($r = @mysql_fetch_array($sql)) {
$s = "";$fetch = "";$pab = "";$rab = "";


$s = @mysql_query("SELECT * FROM ".$pre."fields WHERE type = 'textarea' AND cat = '".$r[section]."' ORDER BY `id` ASC LIMIT 1");
while($x = @mysql_fetch_array($s)) {
$fetch = @mysql_fetch_row(@mysql_query("SELECT data FROM ".$pre."fielddata WHERE fname = '".$x[name]."' AND aid = '".$r[id]."'"));
if ($fetch[0]) {
$datas[] = $fetch[0];
}
}
if ($datas) {
@asort($datas);
while (list($k,$i) = @each($datas)) {
if ($i) {
$data = $i;
}
}
} else {
$data = "No Description";
}

$cnum2 = @mysql_num_rows(@mysql_query("SELECT * FROM ".$pre."comments WHERE aid = '".$r[id]."'"));
$pab[0] = "{link}";
$pab[1] = "{date}";
$pab[2] = "{story}";
$pab[3] = "{comments}";
$pab[4] = "{cnum}";
$pab[5] = "{pcomment}";
$pab[6] = "{author}";
$pab[7] = "{section}";
$pab[8] = "{cat}";
$pab[9] = "{url}";
$pab[10] = "{title}";
$pab[11] = "{subject}";
$pab[12] = "{name}";
$pab[13] = "{username}";
$pab[14] = "{id}";
$pab[15] = "{views}";
$pab[16] = "{social_icons}";

$n = "16";
$sql_rels = mysql_query("SELECT * FROM ".$pre."sections");
while ($q = mysql_fetch_array($sql_rels)) {
$n = $n + 1;
$mane = str_replace(" ","_",$q[name]);
$pab[$n] = "{".$mane.";";
$n = $n + 1;
$pab[$n] = ";".$mane."}";
}

$sec_type = mysql_fetch_row(mysql_query("SELECT type FROM ".$pre."sections WHERE name = '".$r[section]."'"));
$type = $sec_type[0];

$sql_rel = mysql_query("SELECT * FROM ".$pre."relations WHERE ".$type." = '".$r[section]."'");
while ($rel = mysql_fetch_array($sql_rel)) {
if ($type == "section") {
$name = $rel[sub];
} else {
$name = $rel[section];
}
$relations_sec[] = $name;


$check = mysql_fetch_row(mysql_query("SELECT id FROM ".$pre."articles WHERE section = '".$name."' AND name LIKE '%" . addslashes($r[name]) . "%' AND ver = ''"));

$sqlst = mysql_query("SELECT * FROM ".$pre."fielddata WHERE fname = '".$name."' AND aid = '".$r[id]."'");
while ($sr = mysql_fetch_array($sqlst)) {
$relations_id[$name][] = $sr[data];
}
if ($check[0]) {
$relations_id[$name][] = $check[0];
}
}

while (list($idy,$x) = @each($relations_id)) {
$idr[$idy] = $x[0];
}

$rab[0] .= "<a href='".$mrw_1["content"].fthrough($r[name], $r[section], $r[id])."'>".stripslashes($r[name])."</a>";
if ((($lev == "1") or ($lev == "2") && ($r[username] == $_COOKIE[adaptcms_username]))) {
$rab[0] .= "&nbsp;&nbsp;<a href='admin.php?view=edit_article&id=".$r[id]."&cat=".$r[section]."'><img src='".$siteurl."wysiwyg/edit.gif' border='0'></a>&nbsp;<a href='admin.php?view=delete_article&id=".$r[id]."&cat=".$r[section]."'><img src='".$siteurl."wysiwyg/delete.gif' border='0'></a>";
}
$rab[1] = date($setting["date_format"], $r[date]);
$rab[2] = $data;
$rab[3] = "<a href='".$mrw_1["content"].fthrough($r[name], $r[section], $r[id])."#comments'>Comments</a>";
$rab[4] = $cnum2;
$rab[5] = "<a href='".$mrw_1["content"].fthrough($r[name], $r[section], $r[id])."#comments'>Post a Comment</a>";
$rab[6] = "<a href='".$mrw_1["user"].$r[username]."'>".$r[username]."</a>";
$rab[7] = $r[section];
$rab[8] = $r[section];
$rab[9] = $mrw_1["content"].fthrough($r[name], $r[section], $r[id]);
$rab[10] = $r[name];
$rab[11] = $r[name];
$rab[12] = $r[name];
$rab[13] = "<a href='".$mrw_1["user"].$r[username]."'>".$r[username]."</a>";
$rab[14] = $r[id];
$rab[15] = $r[views];
$rab[16] = soc_bookmark($mrw_1["content"].fthrough($r[name], $r[cat], $r[id]), $r[name], "", $data, 'Y');

$n = "16";
$q = "";
$mane = "";
$sql_relse = mysql_query("SELECT * FROM ".$pre."sections");
while ($q = mysql_fetch_array($sql_relse)) {
$n = $n + 1;
$mane = str_replace(" ","_",$q[name]);
if ($r[section] == $q[name]) {
$rab[$n] = "";
$n = $n + 1;
$rab[$n] = "";
} else {

$y = mysql_fetch_row(mysql_query("SELECT name,section FROM ".$pre."articles WHERE id = '".$idr[$mane]."' AND ver = ''"));

if ($y[0]) {
$rab[$n] = "<a href='".$mrw_1["content"].fthrough($y[0], $y[1], $idr[$mane])."'>";
$n = $n + 1;
$rab[$n] = "</a>";
} else {
$rab[$n] = "";
$n = $n + 1;
$rab[$n] = "";
}
}
}
$content .= str_replace($pab, $rab, stripslashes($temp));
$data = "";$datas = "";
}
return $content;
}

function user_content($temp, $cat, $limit, $sort, $sortby, $user) {
global $pre;
global $mrw_1;
global $mrw;
global $lev;
global $setting;
global $siteurl;

if ($limit == "") {
$limit = "5";
}
if ($sort == "") {
$sort = "id";
}
if ($sortby == "") {
$sortby = "DESC";
}

if ($cat) {
$sql = @mysql_query("SELECT * FROM ".$pre."articles WHERE section = '".$cat."' AND ver = '' AND username = '".$user."' ORDER BY `".$sort."` ".$sortby." LIMIT ".$limit);
} else {
$sql = @mysql_query("SELECT * FROM ".$pre."articles WHERE ver = '' AND username = '".$user."' ORDER BY `".$sort."` ".$sortby." LIMIT ".$limit);
}
while($r = @mysql_fetch_array($sql)) {
$s = "";$fetch = "";$pab = "";$rab = "";


$s = @mysql_query("SELECT * FROM ".$pre."fields WHERE type = 'textarea' AND cat = '".$r[section]."'");
while($x = @mysql_fetch_array($s)) {
$fetch = @mysql_fetch_row(@mysql_query("SELECT data FROM ".$pre."fielddata WHERE fname = '".$x[name]."' AND aid = '".$r[id]."'"));
if ($fetch[0]) {
$datas[] = $fetch[0];
}
}
if ($datas) {
@asort($datas);
while (list($k,$i) = @each($datas)) {
if ($i) {
$data = $i;
}
}
} else {
$data = "No Description";
}

$cnum2 = @mysql_num_rows(@mysql_query("SELECT * FROM ".$pre."comments WHERE aid = '".$r[id]."'"));
$pab[0] = "{link}";
$pab[1] = "{date}";
$pab[2] = "{story}";
$pab[3] = "{comments}";
$pab[4] = "{cnum}";
$pab[5] = "{pcomment}";
$pab[6] = "{author}";
$pab[7] = "{section}";
$pab[8] = "{cat}";
$pab[9] = "{url}";
$pab[10] = "{title}";
$pab[11] = "{subject}";
$pab[12] = "{name}";
$pab[13] = "{username}";
$rab[0] .= "<a href='".$mrw_1["content"].fthrough($r[name], $r[section], $r[id])."'>".stripslashes($r[name])."</a>";
if ((($lev == "1") or ($lev == "2") && ($r[username] == $_COOKIE[adaptcms_username]))) {
$rab[0] .= "&nbsp;&nbsp;<a href='admin.php?view=edit_article&id=".$r[id]."&cat=".$r[section]."'><img src='".$siteurl."wysiwyg/edit.gif' border='0'></a>&nbsp;<a href='admin.php?view=delete_article&id=".$r[id]."&cat=".$r[section]."'><img src='".$siteurl."wysiwyg/delete.gif' border='0'></a>";
}
$rab[1] = date($setting["date_format"], $r[date]);
$rab[2] = $data;
$rab[3] = "<a href='".$mrw_1["content"].fthrough($r[name], $r[section], $r[id])."#comments'>Comments</a>";
$rab[4] = $cnum2;
$rab[5] = "<a href='".$mrw_1["content"].fthrough($r[name], $r[section], $r[id])."#comments'>Post a Comment</a>";
$rab[6] = "<a href='".$mrw_1["user"].$r[username]."'>".$r[username]."</a>";
$rab[7] = $r[section];
$rab[8] = $r[section];
$rab[9] = $mrw_1["content"].fthrough($r[name], $r[section], $r[id]);
$rab[10] = $r[name];
$rab[11] = $r[name];
$rab[12] = $r[name];
$rab[13] = "<a href='".$mrw_1["user"].$r[username]."'>".$r[username]."</a>";
$content .= str_replace($pab, $rab, stripslashes($temp));
$data = "";$datas = "";
}
return $content;
}

function template($name, $data) {
global $pre;

$r = mysql_fetch_row(mysql_query("SELECT template FROM ".$pre."templates WHERE name = '".$name."'"));
return str_replace("{name}", $data, $r[0]);
}

function layout($layout) {
global $pre;
global $setting;
global $lev;
global $mrw_1;
global $mrw;

$r = mysql_fetch_row(mysql_query("SELECT template FROM ".$pre."templates WHERE name = 'layout'"));
$ex = explode("{content}", stripslashes($r[0]));

$prep[0] = "{pages}";
$prep[1] = "{categories}";
$prep[2] = "{sections}";

$sql2 = mysql_query("SELECT * FROM ".$pre."pages ORDER BY `name` ASC");
while($c = @mysql_fetch_array($sql2)) {
$rep[0] .= "<br /><a href='".$mrw_1["page"].stripslashes($c[url])."'>".stripslashes($c[name])."</a>";
}
$sql1 = mysql_query("SELECT * FROM ".$pre."sections ORDER BY `name` ASC");
while($a = @mysql_fetch_array($sql1)) {
$rep[1] .= "<br /><a href='".$mrw_1["section"].fthrough($a[name], "", "")."'>".$a[name]."</a>";
$rep[2] .= "<br /><a href='".$mrw_1["section"].fthrough($a[name], "", "")."'>".$a[name]."</a>";
}

$var1 = str_replace($prep, $rep, $ex[0]);
$var2 = str_replace($prep, $rep, $ex[1]);

if ($layout == "header") {
return '<?php if (($_COOKIE[\'adaptcms_skin\']) or ($_POST[\'skin\'])) {
if ($_COOKIE[\'adaptcms_skin\']) {
$skin = $_COOKIE[\'adaptcms_skin\'];
}
if ($_POST[\'skin\']) {
$skin = $_POST[\'skin\'];
}
} else {
$skin = "skin1";
}
if ($skin == "skin1") {
$color = "#feb011";
$color2 = "#4A4A4A";
}
if ($skin == "skin2") {
$color = "#db1c1c";
$color2 = "white";
}
if ($skin == "skin3") {
$color = "#5400ff";
$color2 = "white";
}
if ($skin == "skin4") {
$color = "#176b12";
$color2 = "white";
}
if ($skin == "skin5") {
$color = "#64126b";
$color2 = "white";
}

$num1 = @mysql_num_rows(@mysql_query("SELECT * FROM ".$pre."articles AND ver = \'\'"));
$time = "0";
$qquery = mysql_query("SELECT * FROM ".$pre."users ORDER BY `id` DESC");
while($q = mysql_fetch_array($qquery)) {
$time1 = "";
$time2 = "";
$time1 = time() - 901;
$time2 = time() + 1;
if (($q[logged] < $time2) && ($q[logged] > $time1)) {
$time = $time + 1;
}
}
$user = $_COOKIE[adaptcms_username];
$num1 = @mysql_num_rows(@mysql_query("SELECT * FROM ".$pre."articles WHERE ver = \'\'"));?>'.$var1;
} else {
return $var2;
}
}

function RemoveXSS($val) {
   // remove all non-printable characters. CR(0a) and LF(0b) and TAB(9) are allowed
   // this prevents some character re-spacing such as <java\0script>
   // note that you have to handle splits with \n, \r, and \t later since they *are* allowed in some inputs
   $val = preg_replace('/([\x00-\x08][\x0b-\x0c][\x0e-\x20])/', '', $val);
   
   // straight replacements, the user should never need these since they're normal characters
   // this prevents like <IMG SRC=&#X40&#X61&#X76&#X61&#X73&#X63&#X72&#X69&#X70&#X74&#X3A&#X61&#X6C&#X65&#X72&#X74&#X28&#X27&#X58&#X53&#X53&#X27&#X29>
   $search = 'abcdefghijklmnopqrstuvwxyz';
   $search .= 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
   $search .= '1234567890!@#$%^&*()';
   $search .= '~`";:?+/={}[]-_|\'\\';
   for ($i = 0; $i < strlen($search); $i++) {
      // ;? matches the ;, which is optional
      // 0{0,7} matches any padded zeros, which are optional and go up to 8 chars
   
      // &#x0040 @ search for the hex values
      $val = preg_replace('/(&#[x|X]0{0,8}'.dechex(ord($search[$i])).';?)/i', $search[$i], $val); // with a ;
      // &#00064 @ 0{0,7} matches '0' zero to seven times
      $val = preg_replace('/(&#0{0,8}'.ord($search[$i]).';?)/', $search[$i], $val); // with a ;
   }
   
   // now the only remaining whitespace attacks are \t, \n, and \r
   $ra1 = Array('javascript', 'vbscript', 'expression', 'applet', 'meta', 'xml', 'blink', 'link', 'style', 'script', 'embed', 'object', 'iframe', 'frame', 'frameset', 'ilayer', 'layer', 'bgsound', 'title', 'base');
   $ra2 = Array('onabort', 'onactivate', 'onafterprint', 'onafterupdate', 'onbeforeactivate', 'onbeforecopy', 'onbeforecut', 'onbeforedeactivate', 'onbeforeeditfocus', 'onbeforepaste', 'onbeforeprint', 'onbeforeunload', 'onbeforeupdate', 'onblur', 'onbounce', 'oncellchange', 'onchange', 'onclick', 'oncontextmenu', 'oncontrolselect', 'oncopy', 'oncut', 'ondataavailable', 'ondatasetchanged', 'ondatasetcomplete', 'ondblclick', 'ondeactivate', 'ondrag', 'ondragend', 'ondragenter', 'ondragleave', 'ondragover', 'ondragstart', 'ondrop', 'onerror', 'onerrorupdate', 'onfilterchange', 'onfinish', 'onfocus', 'onfocusin', 'onfocusout', 'onhelp', 'onkeydown', 'onkeypress', 'onkeyup', 'onlayoutcomplete', 'onload', 'onlosecapture', 'onmousedown', 'onmouseenter', 'onmouseleave', 'onmousemove', 'onmouseout', 'onmouseover', 'onmouseup', 'onmousewheel', 'onmove', 'onmoveend', 'onmovestart', 'onpaste', 'onpropertychange', 'onreadystatechange', 'onreset', 'onresize', 'onresizeend', 'onresizestart', 'onrowenter', 'onrowexit', 'onrowsdelete', 'onrowsinserted', 'onscroll', 'onselect', 'onselectionchange', 'onselectstart', 'onstart', 'onstop', 'onsubmit', 'onunload');
   $ra = array_merge($ra1, $ra2);
   
   $found = true; // keep replacing as long as the previous round replaced something
   while ($found == true) {
      $val_before = $val;
      for ($i = 0; $i < sizeof($ra); $i++) {
         $pattern = '/';
         for ($j = 0; $j < strlen($ra[$i]); $j++) {
            if ($j > 0) {
               $pattern .= '(';
               $pattern .= '(&#[x|X]0{0,8}([9][a][b]);?)?';
               $pattern .= '|(&#0{0,8}([9][10][13]);?)?';
               $pattern .= ')?';
            }
            $pattern .= $ra[$i][$j];
         }
         $pattern .= '/i';
         $replacement = substr($ra[$i], 0, 2).'<x>'.substr($ra[$i], 2); // add in <> to nerf the tag
         $val = preg_replace($pattern, $replacement, $val); // filter out the hex tags
         if ($val_before == $val) {
            // no replacements were made, so exit the loop
            $found = false;
         }
      }
   }
}

function reporterror($page, $error, $domain) {
global $email;
global $setting;

$sub = "[AdaptCMS] Error Reported";
$msg = "The error has been repoted from the ".$domain." website, below is the information on the error\n\nPage: ".$page."\nError: ".$error."\n\nThe error has also been reported to the error database. Thank you.";
$headers  = 'MIME-Version: 1.0' . "\r\n";
$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
$headers .= "From: ".$setting["sitename"]." <".$email.">"."\r\n";
$headers .= "Reply-To: ".$email."\r\n";

@mail("errors@adaptcms.com", $sub, $msg, $headers);
return "<iframe src='http://www.adaptcms.com/error.php?domain=".$domain."&error=".urlencode($error)."&page=".$page."' width='0' height='0' frameborder='0'></iframe>";
}

function mail_attachment($filename, $path, $mailto, $from_mail, $from_name, $replyto, $subject, $message) {
    $file = $path.$filename;
    $file_size = filesize($file);
    $handle = fopen($file, "r");
    $content = fread($handle, $file_size);
    fclose($handle);
    $content = chunk_split(base64_encode($content));
    $uid = md5(uniqid(time()));
    $name = basename($file);
    $header = "From: ".$from_name." <".$from_mail.">\r\n";
    $header .= "Reply-To: ".$replyto."\r\n";
    $header .= "MIME-Version: 1.0\r\n";
    $header .= "Content-Type: multipart/mixed; boundary=\"".$uid."\"\r\n\r\n";
    $header .= "This is a multi-part message in MIME format.\r\n";
    $header .= "--".$uid."\r\n";
    $header .= "Content-type:text/plain; charset=iso-8859-1\r\n";
    $header .= "Content-Transfer-Encoding: 7bit\r\n\r\n";
    $header .= $message."\r\n\r\n";
    $header .= "--".$uid."\r\n";
    $header .= "Content-Type: application/octet-stream; name=\"".$filename."\"\r\n"; // use diff. tyoes here
    $header .= "Content-Transfer-Encoding: base64\r\n";
    $header .= "Content-Disposition: attachment; filename=\"".$filename."\"\r\n\r\n";
    $header .= $content."\r\n\r\n";
    $header .= "--".$uid."--";
    if (mail($mailto, $subject, "", $header)) {
        return "mail send ... OK"; // or use booleans here
    } else {
        return "mail send ... ERROR!";
    }
} 

function pointcount($user) {
global $pre;
global $regdate;

$math1 = time() - $regdate;
$math2 = $math1 / 86400;

if ($user == "") {
$username = $_COOKIE[adaptcms_username];
} else {
$username = $user;
}

$num1 = mysql_num_rows(mysql_query("SELECT * FROM ".$pre."articles WHERE username = '".$username."' AND ver = ''"));
$count2 = mysql_num_rows(mysql_query("SELECT * FROM ".$pre."comments WHERE author = '".$username."'"));
$num3 = mysql_num_rows(mysql_query("SELECT * FROM ".$pre."stats WHERE username = '".$username."'"));

$count1 = $num1 * 3;
$count3 = $num3 * .1;
if ($math2 < 8) {
$count4 = $math2 * 5;
} else {
$count4 = $math2 * .5;
}

$final = $count1 + $count2 + $count3 + $count4;

$final = round($final,0);
return substr($final,0,3);
}

function myquery ($query) {
$result = mysql_query($query);
if (mysql_errno())
echo "<b>MySQL error</b> ".mysql_errno().": ".mysql_error()."\n<br /><b>When executing:</b><br />\n$query\n<br /><br />";
return $result;
}

function wysiwyg() {
return '<script language="javascript" type="text/javascript" src="wysiwyg/jscripts/tiny_mce/tiny_mce.js"></script>
<script language="javascript" type="text/javascript">
	tinyMCE.init({
		theme : "advanced",
		mode : "textareas",
		plugins : "save,emotions,iespell,preview,searchreplace,youtube,jacuba",
	    theme_advanced_buttons2_add : "preview,forecolor,backcolor,search,replace,emotions,iespell,youtube,jacuba",
		debug : false
	});</script>';
}

function re_direct($time, $url) {
return "<SCRIPT LANGUAGE='JavaScript'>
redirTime = '".$time."';
redirURL = '".$url."';
function redirTimer() { self.setTimeout('self.location.href = redirURL;',redirTime); }
</script><BODY onLoad='redirTimer()'>";
}

function validate_email($email) {
   $regexp = "^([_a-z0-9-]+)(\.[_a-z0-9-]+)*@([a-z0-9-]+)(\.[a-z0-9-]+)*(\.[a-z]{2,4})$";
   $valid = 0;
   if (eregi($regexp, $email)) {
   list($username,$domaintld) = split("@",$email);
   if (getmxrr($domaintld,$mxrecords))
   $valid = 1;
   } else {
   $valid = 0;
   }
   return $valid;
}

function aheader() {
global $setting;
global $domain;
global $pre;
global $level;
global $mrw_1;
global $mrw;
global $key;

$user = $_COOKIE[adaptcms_username];

if (($_COOKIE['adaptcms_skin']) or ($_POST['skin'])) {
if ($_COOKIE['adaptcms_skin']) {
$skin = $_COOKIE['adaptcms_skin'];
}
if ($_POST['skin']) {
$skin = $_POST['skin'];
}
} else {
$skin = "skin1";
}
if ($skin == "skin1") {
$color = "#feb011";
$color2 = "#4A4A4A";
}
if ($skin == "skin2") {
$color = "#db1c1c";
$color2 = "white";
}
if ($skin == "skin3") {
$color = "#5400ff";
$color2 = "white";
}
if ($skin == "skin4") {
$color = "#176b12";
$color2 = "white";
}
if ($skin == "skin5") {
$color = "#64126b";
$color2 = "white";
}
$temp .= '<script language="javascript">function jump(targ,selObj,restore){
eval(targ+".location=\'"+selObj.options[selObj.selectedIndex].value+"\'");
if (restore) selObj.selectedIndex=0;
}</script>';
$temp .= "<script language='javascript'>function awindow(towhere, newwinname, properties) {window.open(towhere,newwinname,properties);}</script><STYLE type='text/css'>body { font-family: tahoma;font-size: 11px;color: #4a4a4a; }td { font-family: tahoma;font-size: 11px;color: #4a4a4a;}a:link {color: #4a4a4a; text-decoration: none;font-weight: bold}a:visited {color: #4a4a4a; text-decoration: none;font-weight: bold} a:active {color: #4a4a4a; text-decoration: none;font-weight: bold} a:hover {text-decoration: none; color: #4a4a4a;font-weight: bold}a:visited:hover {text-decoration: none; color: #4a4a4a;font-weight: bold</style>

<table cellpadding='0' cellspacing='0' width='757' border='0' align='center'><tr><td>

<table cellpadding='0' cellspacing='0' width='757' border='0' align='center'><tr><td><img src='".$skin."/top.png'></td></tr></table><br />

<table cellpadding='0' cellspacing='0' border='0'><tr><td align='left' valign='top'>

<table cellpadding='0' cellspacing='0' border='0'><tr><td background='wysiwyg/leftbg.png' height='281' width='168' align='left' valign='top'><img src='".$skin."/menu1.png'>

<form name='form1'><table cellpadding='10' cellspacing='0' border='0' width='center'><tr><td>";
if ($_GET['view'] == "denied") {
$temp .= "<a href='index.php'>Main Site</a><br />";
} else {
$temp .= "<a href='index.php'>Main Site</a><br />
<a href='admin.php'>Admin Panel</a><br />
<a href='admin.php?view=support'>Support</a><br />
<a href='admin.php?view=tools'>Tools</a><br /><br />
<a href='admin.php?view=articles'>Articles</a><br />
<a href='admin.php?view=comments'>Comments</a><br />
<a href='admin.php?view=files'>Files</a><br />
<a href='admin.php?view=gallery'>Gallery</a><br />
<a href='admin.php?view=pages'>Pages</a><br />
<a href='admin.php?view=plugins'>Plugins</a><br />";
$temp .= "<a href='admin.php?view=polls'>Polls</a><br />
<a href='admin.php?view=sections'>Sections</a><br />
<a href='admin.php?view=stats'>Stats</a><br /><br />
<center><a href='javascript:awindow(\"http://www.adaptcms.com/s2smessages_lite.php?domain=".$domain."&key=".$key."\", \"\", \"width=600,height=400,scroll=yes,toolbar=no,directories=no,status=no,menubar=no,resizable=yes\")'>S2S messages</a><br /><br />

<select name='quickadd' style='font-family: tahoma; font-size: 11px; border: 1px solid #444444' onChange=\"jump('parent',this,0)\"><option value=''>-- Quick Add --</option>";
$sql = @mysql_query("SELECT * FROM ".$pre."sections ORDER BY `type` ASC, `name` ASC");
while($r = @mysql_fetch_array($sql)) {
$p = "";
$p = @mysql_fetch_row(@mysql_query("SELECT padd FROM ".$pre."permissions WHERE level = '".$level."' AND name = '".$r[name]."'"));
if ($p[0]) {
$temp .= "<option value='admin.php?view=quick_add_articles&cat=".$r[name]."'>".ucwords($r[name])."</option>";
}
}
$temp .= "</select></form></center>";
}
$temp .= "</td></tr></table>
</td></tr></table><br />

<table cellpadding='0' cellspacing='0' border='0'><tr><td background='wysiwyg/leftbg.png' height='281' width='168' align='left' valign='top'><img src='".$skin."/menu2.png'>

<table cellpadding='10' cellspacing='0' border='0' width='center'><tr><td>";
if ($_GET['view'] == "denied") {
} else {
$temp .= "<a href='admin.php?view=fields'>Custom Fields</a><br />
<a href='admin.php?view=mass_email'>Mass E-Mail</a><br />
<a href='admin.php?view=permissions'>Permissions</a><br />
<a href='admin.php?view=ranks'>Ranks</a><br />
<a href='admin.php?view=settings'>Settings</a><br />
<a href='admin.php?view=templates'>Templates</a><br />
<a href='admin.php?view=levels'>User Levels</a><br />
<a href='admin.php?view=users'>Users</a><br /><br /><br />".translate();
}
$temp .= "</td></tr></table>

</td></tr></table>


</td><td valign='top' width='591' align='center'><table cellpadding='1' cellspacing='0' border='0' width='100%'><tr><td align='center'>";
$num1 = @mysql_num_rows(@mysql_query("SELECT * FROM ".$pre."articles WHERE ver = ''"));
$time = "0";
$qquery = @mysql_query("SELECT * FROM ".$pre."users ORDER BY `id` DESC");
while($q = @mysql_fetch_array($qquery)) {
$time1 = "";
$time2 = "";
$time1 = time() - 901;
$time2 = time() + 1;
if (($q[logged] < $time2) && ($q[logged] > $time1)) {
$time = $time + 1;
}
}
if ($_COOKIE[adaptcms_username]) {
$temp .= "Welcome back <a href='".$mrw["profile"]."'>".mysql_real_escape_string(stripslashes($_COOKIE[adaptcms_username]))."</a>. There are <a href='admin.php'>".$num1."</a> articles, <a href='admin.php'>".$time."</a> users online at <a href='http://www.".$domain."'>".$domain."</a> - ";
$temp.= @pointcount("")." points";
} else {
$temp .= "Welcome <b>Guest</b>. Please <a href='".$mrw_1["login"]."'>Login</a> or <a href='".$mrw_1["register"]."'>Sign-Up</a> to use some features of ".ucwords($domain);
}

$temp .= "</td><td align='right'><form action='".$_SERVER['REQUEST_URI']."' method='post'><select name='skin' style='background-color: ".$color.";color: ".$color2.";font-size: 11px;font-face: tahoma;font-weight: bold' onchange='this.form.submit()'><option value='skin1' style='background-color: ".$color.";color: ".$color2.";font-size: 11px;font-face: tahoma;font-weight: bold' selected> - Choose Skin -</option><option value='skin1' style='background-color: #feb011;color: #4a4a4a;font-size: 11px;font-face: tahoma;font-weight: bold'>Orange Skin</option><option value='skin2' style='background-color: #db1c1c;color: white;font-size: 11px;font-face: tahoma;font-weight: bold'>Red Skin</option><option value='skin3' style='background-color: #5400ff;color: white;font-size: 11px;font-face: tahoma;font-weight: bold'>Blue Skin</option><option value='skin4' style='background-color: #176b12;color: white;font-size: 11px;font-face: tahoma;font-weight: bold'>Green Skin</option><option value='skin5' style='background-color: #64126b;color: white;font-size: 11px;font-face: tahoma;font-weight: bold'>Dark Skin</option></select></form></td></tr></table><br /><table cellpadding='0' cellspacing='0' border='0' width='center'><tr><td background='wysiwyg/contentbg.png' height='100%' width='518' valign='top' align='left'><img src='".$skin."/content.png'><table cellpadding='10' cellspacing='0' border='0' width='center'><tr><td>";
return $temp;
}

function afooter() {
return "</td></tr></table>

</td></tr></table>

<a href='http://www.adaptcms.com'><img src='wysiwyg/footer1.png' border='0'></a>

</td></tr></table>
</td></tr></table>

</body></html>";
}
?>